/**
 * 
 */
package jalview.gui;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Hashtable;
import java.util.IdentityHashMap;
import java.util.Vector;
import java.util.jar.JarOutputStream;

import javax.swing.JInternalFrame;

import jalview.bin.Cache;

import org.vamsas.client.UserHandle;
import org.vamsas.client.simpleclient.FileWatcher;
import org.vamsas.client.simpleclient.VamsasArchive;
import org.vamsas.client.simpleclient.VamsasFile;
import org.vamsas.objects.core.VamsasDocument;
import org.vamsas.test.simpleclient.ArchiveClient;
import org.vamsas.test.simpleclient.ClientDoc;

/**
 * @author jimp
 *
 */
public class VamsasClient extends ArchiveClient {
	Desktop us;
	// Cache.preferences for vamsas client session arena
	// preferences for check for default session at startup.
	// user and organisation stuff.
	public VamsasClient(Desktop jdesktop,
			File sessionPath) {
		super(System.getProperty("user.name"),System.getProperty("host.name"), "jalview","2.7",
				sessionPath);
		us=jdesktop;
	}
	public void initial_update() {
		Cache.log.info("Jalview loading the Vamsas Session.");
		// load in the vamsas archive for the first time
		ClientDoc cdoc = this.getUpdateable();
		updateJalview(cdoc);
		
	}
	/**
	 * this will close all windows currently in Jalview.
	 *
	 */
	protected void closeWindows() {
		JInternalFrame[] frames = Desktop.desktop.getAllFrames();

        if (frames == null)
        {
            return;
        }

        try
        {	
            for (int i = frames.length - 1; i > -1; i--) {
            	frames[i].dispose();	
            }
        } catch (Exception e) {
        	Cache.log.error("Whilst closing windows",e);
        }
		
	}
	public void get_update(VamsasArchive doc) {
		// Close windows - load update.
		Cache.log.info("Jalview updating from Vamsas Session.");
	}
	public void push_update() {
		// collect all uncached alignments and put them into the vamsas dataset.
		// store them.
		Cache.log.info("Jalview updating the Vamsas Session.");
	}
	public void end_session() {
		// stop any update/watcher thread.
		Cache.log.info("Jalview disconnecting from the Vamsas Session.");
	}
	public void updateJalview(ClientDoc cdoc) {
		
	}
	protected void _updateAlignFrame(ClientDoc cdoc, AlignFrame av) {
		
	}
	/**
	 * jalview object binding to VorbaIds
	 */
	IdentityHashMap jv2vobj = null;
	Hashtable vobj2jv = null;
	public void updateVamsasDocument(ClientDoc doc) {
		if (jv2vobj==null) {
			jv2vobj = new IdentityHashMap();
			vobj2jv = new Hashtable();
		}
		// wander through frames 
		JInternalFrame[] frames = Desktop.desktop.getAllFrames();

        if (frames == null)
        {
            return;
        }

        try
        {	
        	// Mapping
        	// Alignframe.alignment (non-null dataset)==alignment
        	// alignframe .alignment (dataset==null) = VAMAS[]
        	// Tree.alignment = vamsas[].tree (vamsas[] given by dataset, alignment given by local ref]
        	
        	Vector shortNames = new Vector();
        	
        	//REVERSE ORDER
            for (int i = frames.length - 1; i > -1; i--)
            {
                if (frames[i] instanceof AlignFrame)
                {
                	AlignFrame af = (AlignFrame) frames[i];
                	
                	// check if this frame has an associated alignment object ?
                	
                	// update alignment and root from frame.

                }
            }
        }
        catch (Exception e) {
        	Cache.log.error("Vamsas Document store exception",e);
        }
	}
	protected class VamsasClientWatcher extends Thread implements Runnable {
		/* (non-Javadoc)
		 * @see java.lang.Thread#run()
		 */
		VamsasClient client=null;
		VamsasClientWatcher(VamsasClient client) {
			this.client = client;
		}
		public void run() {
			ClientDoc docio = client.watch(0);
			
		}
		
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
